diff -x asm -Naur linux-2.4.30-orig/drivers/char/rtc.c linux-2.4.30/drivers/char/rtc.c
--- linux-2.4.30-orig/drivers/char/rtc.c	2005-05-12 17:57:21.000000000 +0200
+++ linux-2.4.30/drivers/char/rtc.c	2006-12-11 18:18:37.000000000 +0100
@@ -44,1125 +114,1145 @@
  *	1.10f	Maciej W. Rozycki: Handle memory-mapped chips properly.
  */
 
-#define RTC_VERSION		"1.10f"
-
-/*
- *	Note that *all* calls to CMOS_READ and CMOS_WRITE are done with
- *	interrupts disabled. Due to the index-port/data-port (0x70/0x71)
- *	design of the RTC, we don't want two different things trying to
- *	get to it at once. (e.g. the periodic 11 min sync from time.c vs.
- *	this driver.)
- */
+#define DRIVER "AMD Alchemy Au1550 RTC Driver "
+#define RTC_VERSION "v0.6"
 
 #include <linux/config.h>
-#include <linux/module.h>
-#include <linux/kernel.h>
-#include <linux/types.h>
-#include <linux/miscdevice.h>
-#include <linux/ioport.h>
-#include <linux/fcntl.h>
-#include <linux/mc146818rtc.h>
-#include <linux/init.h>
-#include <linux/poll.h>
-#include <linux/proc_fs.h>
-#include <linux/spinlock.h>
-#include <linux/sysctl.h>
-
-#include <asm/io.h>
-#include <asm/uaccess.h>
+#include <linux/module.h>     /* THIS_MODULE MODULE_* EXPORT_NO_SYMBOLS config.h spinlock.h list.h */
+#include <linux/kernel.h>     /* KERN_WARNING etc */
+#include <linux/miscdevice.h> /* RTC_MINOR miscdevice misc_*register */
+                              /* devfs_fs_kernel.h: -> fs.h  config.h spinlock.h */
+                              /* kdev_t.h types.h: (s)size_t loff_t*/
+                              /* fs.h: file_operations no_llseek -> config.h */
+                              /* limits.h wait.h: wait_queue_head_t DECLARE_WAIT_QUEUE_HEAD */
+                              /* types.h vfs.h net.h kdev_t.h */
+                              /* ioctl.h list.h dcache.h stat.h cache.h stddef.h */
+                              /* linkage.h string.h atomic.h bitops.h */
+#include <linux/init.h>       /* __init __exit module_init module_exit config.h compiler.h */
+#include <linux/proc_fs.h>    /* remove_proc_entry create_proc_read_entry */
+#include <linux/spinlock.h>   /* spinlock_t SPIN_LOCK_UNLOCKED spin_lock_irqsave */
+                              /* config.h system.h */
+#include <asm/io.h>           /* readl, writel */
+#include <asm/uaccess.h>      /* copy_*_user put_user */
 #include <asm/system.h>
+#include <asm/errno.h>        /* EACCES etc */
+#include <asm/au1000.h>       /* SYS & IC register addresses, SYS_CNTRL masks */
+#include <linux/sched.h>      /* request_irq capable */
+                              /* config.h binfmts.h threads.h kernel.h types.h */
+                              /* times.h timex.h rbtree.h system.h semaphore.h */
+                              /* page.h ptrace.h mmu.h smp.h tty.h sem.h */
+                              /* signal.h securebits.h fs_struct.h */
+#include <linux/capability.h> /* CAP_SYS_TIME */
+
+/* Check configuration */
+#if !defined(CONFIG_MIPS) || !defined(CONFIG_RTC)
+#error "This driver is for AMD Alchemy Au1550 using TOY clock as RTC."
+#endif
+
+#include <asm/time.h> /* ptrace.h: pt_regs, linkage.h rtc.h rtc_time RTC_*_TIME rtc_*_time */
+
+//#define RTC_DEBUG 1
+
+#define RTC_IS_OPEN 0x01 /* means /dev/rtc is in use */
+#define RTCTICK_PTR NULL
+#define TOYTICK_PTR NULL
+#define RTCMATCH0_PTR NULL
+#define TOYMATCH0_PTR NULL
+
+const unsigned int epoch = 1900;
+const unsigned long trim_default = 7; 
+const unsigned long freq = 1000; /* external clock frequency in Hz */
+const unsigned long timeout = 100000; /* at least one tick */
+/* ticks 1900: 365 * 24 * 60 * 60 * freq / (trim_default + 1) */
+const unsigned long yearly_ticks_default = 0xEAF62580; /* 3942000000 */
+const unsigned long yearly_seconds_normal = 31536000;
+const unsigned long addl_seconds_leap     = 86400;
+
+static unsigned long rtc_status = 0;	
+static unsigned long year_irq = 0;	
+static unsigned long eon_irq = 0;	
+static unsigned long spurious_irq = 0;	
+static unsigned long write_error = 0;	
+#ifdef RTC_DEBUG
+static unsigned long cp0_status = 0xFFFFFFFF;
+static unsigned long cp0_cause = 0xFFFFFFFF;
+//static unsigned long ic0_risingrd = 0xFFFFFFFF;
+//static unsigned long ic0_fallingrd = 0xFFFFFFFF;
+//static unsigned long ic0_req0int = 0xFFFFFFFF;
+static unsigned short sometimes = 0;
+static unsigned long tick_stat [256];
+static int sleep_diff = -1234;       /* a negative value far from 0 */
+#endif
+
+/* rtc_read variables section */
+static unsigned char got_period_irq = 0;
+static unsigned char got_tick_irq = 0;
+//static wait_queue_head_t period_q; 
+DECLARE_WAIT_QUEUE_HEAD (period_q);  /* periodic queue */
+static unsigned long new_year = 0;   /* rtc_read needs to remember */
+static unsigned long old_year = 0;   /* rtc_read needs to remember */
+static unsigned long new_cnt = 0;    /* rtc_read needs to remember */
+static unsigned long old_cnt = 0;    /* rtc_read needs to remember */
+static unsigned long new_eon = 0;    /* rtc_read needs to remember */
+static unsigned long old_eon = 0;    /* rtc_read needs to remember */
+static unsigned long new_pcnt = 0;   /* rtc_read needs to remember */
+static unsigned long old_pcnt = 0;   /* rtc_read needs to remember */
+static unsigned char stab = 0;       /* stability, 0 = uninitialized */
+
+static int rtc_read_proc(char *page, char **start, off_t off, int count, int *eof, void *data);
+
+static spinlock_t rtc_init_lock = SPIN_LOCK_UNLOCKED;
+static spinlock_t rtc_open_lock = SPIN_LOCK_UNLOCKED;
+static spinlock_t rtc_set_lock = SPIN_LOCK_UNLOCKED;
 
-#ifdef __sparc__
-#include <linux/pci.h>
-#include <asm/ebus.h>
-#ifdef __sparc_v9__
-#include <asm/isa.h>
-#endif
-
-static unsigned long rtc_port;
-static int rtc_irq = PCI_IRQ_NONE;
-#endif
-
-#if RTC_IRQ
-static int rtc_has_irq = 1;
-#endif
-
-/*
- *	We sponge a minor off of the misc major. No need slurping
- *	up another valuable major dev number for this. If you add
- *	an ioctl, make sure you don't conflict with SPARC's RTC
- *	ioctls.
- */
-
-static struct fasync_struct *rtc_async_queue;
-
-static DECLARE_WAIT_QUEUE_HEAD(rtc_wait);
-
-#if RTC_IRQ
-static struct timer_list rtc_irq_timer;
-#endif
-
-static ssize_t rtc_read(struct file *file, char *buf,
-			size_t count, loff_t *ppos);
-
-static int rtc_ioctl(struct inode *inode, struct file *file,
-		     unsigned int cmd, unsigned long arg);
-
-#if RTC_IRQ
-static unsigned int rtc_poll(struct file *file, poll_table *wait);
-#endif
-
-static void get_rtc_time (struct rtc_time *rtc_tm);
-static void get_rtc_alm_time (struct rtc_time *alm_tm);
-#if RTC_IRQ
-static void rtc_dropped_irq(unsigned long data);
-
-static void set_rtc_irq_bit(unsigned char bit);
-static void mask_rtc_irq_bit(unsigned char bit);
-#endif
-
-static inline unsigned char rtc_is_updating(void);
-
-static int rtc_read_proc(char *page, char **start, off_t off,
-                         int count, int *eof, void *data);
-
-/*
- *	Bits in rtc_status. (6 bits of room for future expansion)
- */
-
-#define RTC_IS_OPEN		0x01	/* means /dev/rtc is in use	*/
-#define RTC_TIMER_ON		0x02	/* missed irq timer active	*/
-
-/*
- * rtc_status is never changed by rtc_interrupt, and ioctl/open/close is
- * protected by the big kernel lock. However, ioctl can still disable the timer
- * in rtc_status and then with del_timer after the interrupt has read
- * rtc_status but before mod_timer is called, which would then reenable the
- * timer (but you would need to have an awful timing before you'd trip on it)
- */
-static unsigned long rtc_status = 0;	/* bitmapped status byte.	*/
-static unsigned long rtc_freq = 0;	/* Current periodic IRQ rate	*/
-static unsigned long rtc_irq_data = 0;	/* our output to the world	*/
-static unsigned long rtc_max_user_freq = 64; /* > this, need CAP_SYS_RESOURCE */
-
-/*
- *	If this driver ever becomes modularised, it will be really nice
- *	to make the epoch retain its value across module reload...
- */
-
-static unsigned long epoch = 1900;	/* year corresponding to 0x00	*/
-
-static const unsigned char days_in_mo[] = 
-{0, 31, 28, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31};
-
-#if RTC_IRQ
-/*
- *	A very tiny interrupt handler. It runs with SA_INTERRUPT set,
- *	but there is possibility of conflicting with the set_rtc_mmss()
- *	call (the rtc irq and the timer irq can easily run at the same
- *	time in two different CPUs). So we need to serializes
- *	accesses to the chip with the rtc_lock spinlock that each
- *	architecture should implement in the timer code.
- *	(See ./arch/XXXX/kernel/time.c for the set_rtc_mmss() function.)
- */
-
-static void rtc_interrupt(int irq, void *dev_id, struct pt_regs *regs)
-{
-	/*
-	 *	Can be an alarm interrupt, update complete interrupt,
-	 *	or a periodic interrupt. We store the status in the
-	 *	low byte and the number of interrupts received since
-	 *	the last read in the remainder of rtc_irq_data.
-	 */
-
-	spin_lock (&rtc_lock);
-	rtc_irq_data += 0x100;
-	rtc_irq_data &= ~0xff;
-	rtc_irq_data |= (CMOS_READ(RTC_INTR_FLAGS) & 0xF0);
-
-	if (rtc_status & RTC_TIMER_ON)
-		mod_timer(&rtc_irq_timer, jiffies + HZ/rtc_freq + 2*HZ/100);
-
-	spin_unlock (&rtc_lock);
-
-	/* Now do the rest of the actions */
-	wake_up_interruptible(&rtc_wait);	
-
-	kill_fasync (&rtc_async_queue, SIGIO, POLL_IN);
-}
-#endif
-
-/*
- * sysctl-tuning infrastructure.
- */
-static ctl_table rtc_table[] = {
-    { 1, "max-user-freq", &rtc_max_user_freq, sizeof(int), 0644, NULL,
-      &proc_dointvec, NULL, },
-    { 0, }
-};
-
-static ctl_table rtc_root[] = {
-    { 1, "rtc", NULL, 0, 0555, rtc_table, },
-    { 0, }
-};
-
-static ctl_table dev_root[] = {
-    { CTL_DEV, "dev", NULL, 0, 0555, rtc_root, },
-    { 0, }
-};
-
-static struct ctl_table_header *sysctl_header;
-
-static int __init init_sysctl(void)
-{
-    sysctl_header = register_sysctl_table(dev_root, 0);
-    return 0;
-}
-
-static void __exit cleanup_sysctl(void)
+static void au1550_get_time(struct rtc_time *rtc_tm)
 {
-    unregister_sysctl_table(sysctl_header);
-}
+    unsigned long curr_tick;
+    unsigned char mon, leap_yr;
+    unsigned long year, trim;
+    unsigned int daysum;
+    unsigned char days_in_mon[] = {31, 28, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31};
+
+    year=readl(SYS_TOYMATCH2);
+    curr_tick=readl(SYS_TOYREAD);
+    /* Check that new year did not occur right now, if so reread */
+    if ((year == 1 + readl(SYS_TOYREAD))) {
+        curr_tick=readl(SYS_TOYREAD);
+	year++; 
+    }
+
+    trim = readl(SYS_TOYTRIM); /* Divide=sys_toytrim+1, max 16 bits */
+    trim &= 0xFFFF;
+    trim++; 
+    rtc_tm->tm_year = year - epoch;
+    //        tk = curr_tick % (freq / trim); /* left over ticks */
+    curr_tick = curr_tick / (freq / trim);    /* MM-DD hh:mm:ss in seconds */
+    rtc_tm->tm_sec = curr_tick % 60;
+    curr_tick = curr_tick / 60;               /* MM-DD hh:mm in minutes */
+    rtc_tm->tm_min = curr_tick % 60;
+    curr_tick = curr_tick / 60;               /* MM-DD hh in hours */
+    rtc_tm->tm_hour = curr_tick % 24;
+    curr_tick = curr_tick / 24;               /* MM-DD in days */
+    leap_yr = ((!(year % 4) && (year % 100)) || !(year % 400));
+    days_in_mon[1] += leap_yr;                /* tm_mon is in [0;11] */
+
+    mon = 0;
+    daysum = days_in_mon[0];
+    while (curr_tick >= daysum) /* maybe add a check */
+    {
+	mon++;
+        daysum += days_in_mon[mon];
+    }
+    rtc_tm->tm_mon = mon; /* [0;11] */
+    daysum -= days_in_mon[mon];
+    curr_tick -= daysum; /* subtract days of previous months */
+    rtc_tm->tm_mday = curr_tick + 1; /* [1;31] */
+} /* au1550_get_time */
 
-/*
- *	Now all the various file operations that we export.
- */
 
-static ssize_t rtc_read(struct file *file, char *buf,
-			size_t count, loff_t *ppos)
+static int rtc_ioctl(struct inode *inode, struct file *file, unsigned int cmd, unsigned long arg)
 {
-#if !RTC_IRQ
-	return -EIO;
-#else
-	DECLARE_WAITQUEUE(wait, current);
-	unsigned long data;
-	ssize_t retval;
+    struct rtc_time rtc_tm;
+    unsigned long curr_tick, wrap_tick;
+    int year; /* same type as tm_year */
+    unsigned char mon, leap_yr, tick_set;
+    unsigned long trim, rtctrim, attempts, irq_freq;
+    unsigned long cntrctrl;
+    unsigned long rtc_set_flags; /* flags must not be passed to other functions */
+    unsigned char days_in_mon[] = {31, 28, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31};
+#ifdef RTC_DEBUG
+    unsigned short corr;
+#endif
+
+    switch (cmd) {
+    case RTC_RD_TIME: /* Read the time & date from the RTC */
+        au1550_get_time(&rtc_tm);
+
+#ifdef RTC_DEBUG
+	printk(KERN_INFO DRIVER RTC_VERSION ", time read.\n");
+#endif
+	if (copy_to_user((void *) arg, &rtc_tm, sizeof(rtc_tm))) return	-EFAULT;
+        return 0;
+    case RTC_SET_TIME: /* Set the time & date in the RTC */
+	if (!capable(CAP_SYS_TIME)) 
+	    return -EACCES;
+
+	if (copy_from_user(&rtc_tm, (struct rtc_time *) arg, sizeof(struct rtc_time))) 
+            return -EFAULT;
+
+	if ((rtc_tm.tm_year < 0))      /* disqualify tm_year before 1900 */
+	    return -EINVAL;
+	year = rtc_tm.tm_year + epoch; /* tm_year holds "years since 1900" */
+	leap_yr = ((!(year % 4) && (year % 100)) || !(year % 400));
+	days_in_mon[1] += leap_yr;                         /* tm_mon is in [0;11] */
+	if ((rtc_tm.tm_mon > 11) || (rtc_tm.tm_mday == 0)) /* tm_mon is in [0;11] */
+            return -EINVAL;
+	if (rtc_tm.tm_mday > days_in_mon[rtc_tm.tm_mon])
+	    return -EINVAL;
+	if ((rtc_tm.tm_hour >= 24) || (rtc_tm.tm_min >= 60))
+	    return -EINVAL;
+	if ((rtc_tm.tm_sec >= 62)) /* tm_sec allows double leap second */
+	    return -EINVAL;
+        
+	curr_tick = 0;
+	for (mon = 0; mon < rtc_tm.tm_mon; mon++) curr_tick += days_in_mon[mon];
+	curr_tick += rtc_tm.tm_mday - 1; /* days gone this year */
+        curr_tick *= 24;
+        curr_tick += rtc_tm.tm_hour;     /* hours gone this year */
+        curr_tick *= 60;
+        curr_tick += rtc_tm.tm_min;      /* minutes gone this year */
+        curr_tick *= 60;
+        curr_tick += rtc_tm.tm_sec;      /* seconds gone this year */
+ 	trim = readl(SYS_TOYTRIM); /* Divide=sys_toytrim+1, max 16 bits */
+	trim &= 0xFFFF;
+        trim++; 
+	curr_tick = curr_tick * (freq / trim); /* ticks gone this year */
+#ifdef RTC_DEBUG
+	printk(KERN_INFO DRIVER RTC_VERSION ", tick set %09lu.\n", curr_tick);
+#endif
 	
-	if (rtc_has_irq == 0)
-		return -EIO;
-
-	/*
-	 * Historically this function used to assume that sizeof(unsigned long)
-	 * is the same in userspace and kernelspace.  This lead to problems
-	 * for configurations with multiple ABIs such a the MIPS o32 and 64
-	 * ABIs supported on the same kernel.  So now we support read of both
-	 * 4 and 8 bytes and assume that's the sizeof(unsigned long) in the
-	 * userspace ABI.
-	 */
-	if (count != sizeof(unsigned int) && count !=  sizeof(unsigned long))
-		return -EINVAL;
-
-	add_wait_queue(&rtc_wait, &wait);
-		
-	do {
-		__set_current_state(TASK_INTERRUPTIBLE);
-
-		/* First make it right. Then make it fast. Putting this whole
-		 * block within the parentheses of a while would be too
-		 * confusing. And no, xchg() is not the answer. */
-		spin_lock_irq (&rtc_lock);
-		data = rtc_irq_data;
-		rtc_irq_data = 0;
-		spin_unlock_irq (&rtc_lock);
-
-		if (data != 0)
-			break;
-
-		if (file->f_flags & O_NONBLOCK) {
-			retval = -EAGAIN;
-			goto out;
-		}
-		if (signal_pending(current)) {
-			retval = -ERESTARTSYS;
-			goto out;
-		}
-		schedule();
-	} while (1);
-
-	if (count == sizeof(unsigned int))
-		retval = put_user(data, (unsigned int *)buf); 
-	else
-		retval = put_user(data, (unsigned long *)buf);
-	if (!retval)
-		retval = count;
- out:
-	current->state = TASK_RUNNING;
-	remove_wait_queue(&rtc_wait, &wait);
-
-	return retval;
+	wrap_tick = 0;
+	for (mon = 0; mon < 12; mon++) wrap_tick += days_in_mon[mon];
+        wrap_tick = wrap_tick * 24 * 60 * 60 * (freq / trim); /* ticks this year */
+
+	tick_set = 0;
+	for (attempts=0; (attempts<timeout) && (tick_set==0); attempts++) {
+	    spin_lock_irqsave(&rtc_set_lock, rtc_set_flags);
+
+	    cntrctrl=readl(SYS_COUNTER_CNTRL);
+
+	    if (!(cntrctrl & SYS_CNTRCTRL_TS) && !(cntrctrl & SYS_CNTRCTRL_TM0) && !(cntrctrl & SYS_CNTRCTRL_TM2))
+	    { /* can write sys_toywrite & sys_toymatch0 */
+		writel(curr_tick, SYS_TOYWRITE);
+		writel(wrap_tick, SYS_TOYMATCH0);
+		writel(year, SYS_TOYMATCH2);
+		tick_set = 1;
+		if (got_period_irq==0) stab = 0; /* inform rtc_read */
+#ifdef RTC_DEBUG
+		printk(KERN_INFO DRIVER RTC_VERSION ", time set.\n");
 #endif
-}
-
-static int rtc_ioctl(struct inode *inode, struct file *file, unsigned int cmd,
-		     unsigned long arg)
-{
-	struct rtc_time wtime; 
-
-#if RTC_IRQ
-	if (rtc_has_irq == 0) {
-		switch (cmd) {
-		case RTC_AIE_OFF:
-		case RTC_AIE_ON:
-		case RTC_PIE_OFF:
-		case RTC_PIE_ON:
-		case RTC_UIE_OFF:
-		case RTC_UIE_ON:
-		case RTC_IRQP_READ:
-		case RTC_IRQP_SET:
-			return -EINVAL;
-		};
+	    }
+	
+	    spin_unlock_irqrestore(&rtc_set_lock, rtc_set_flags);
 	}
-#endif
+	if (tick_set < 1) return -EAGAIN;
 
-	switch (cmd) {
-#if RTC_IRQ
-	case RTC_AIE_OFF:	/* Mask alarm int. enab. bit	*/
-	{
-		mask_rtc_irq_bit(RTC_AIE);
-		return 0;
-	}
-	case RTC_AIE_ON:	/* Allow alarm interrupts.	*/
-	{
-		set_rtc_irq_bit(RTC_AIE);
-		return 0;
-	}
-	case RTC_PIE_OFF:	/* Mask periodic int. enab. bit	*/
-	{
-		mask_rtc_irq_bit(RTC_PIE);
-		if (rtc_status & RTC_TIMER_ON) {
-			spin_lock_irq (&rtc_lock);
-			rtc_status &= ~RTC_TIMER_ON;
-			del_timer(&rtc_irq_timer);
-			spin_unlock_irq (&rtc_lock);
-		}
-		return 0;
-	}
-	case RTC_PIE_ON:	/* Allow periodic ints		*/
-	{
+	return 0;
+    case RTC_IRQP_SET: /* Set periodic irq frequency */
+        if (got_period_irq == 0) return -EINVAL;
 
-		/*
-		 * We don't really want Joe User enabling more
-		 * than 64Hz of interrupts on a multi-user machine.
-		 */
-		if ((rtc_freq > rtc_max_user_freq) && 
-		    (!capable(CAP_SYS_RESOURCE)))
-			return -EACCES;
-
-		if (!(rtc_status & RTC_TIMER_ON)) {
-			spin_lock_irq (&rtc_lock);
-			rtc_irq_timer.expires = jiffies + HZ/rtc_freq + 2*HZ/100;
-			add_timer(&rtc_irq_timer);
-			rtc_status |= RTC_TIMER_ON;
-			spin_unlock_irq (&rtc_lock);
-		}
-		set_rtc_irq_bit(RTC_PIE);
-		return 0;
-	}
-	case RTC_UIE_OFF:	/* Mask ints from RTC updates.	*/
-	{
-		mask_rtc_irq_bit(RTC_UIE);
-		return 0;
-	}
-	case RTC_UIE_ON:	/* Allow ints for RTC updates.	*/
-	{
-		set_rtc_irq_bit(RTC_UIE);
-		return 0;
-	}
+        /* arg is an integer, accept two values for some fractional f */
+        switch (arg) { /* has to be rewritten if clock freq is changed */
+  	    case     1000: rtctrim =  0; break; /* f=clock/(rtctrim+1)=1000 */
+   	    case      500: rtctrim =  1; break; /* f=clock/(rtctrim+1)=500 */
+  	    case      334: 
+  	    case      333: rtctrim =  2; break; /* f=clock/(rtctrim+1)=333.3 */
+   	    case      250: rtctrim =  3; break; /* f=clock/(rtctrim+1)=250 */
+   	    case      200: rtctrim =  4; break; /* f=clock/(rtctrim+1)=200 */
+  	    case      167: 
+  	    case      166: rtctrim =  5; break; /* f=clock/(rtctrim+1)=166.7 */
+  	    case      143: 
+  	    case      142: rtctrim =  6; break; /* f=clock/(rtctrim+1)=142.8 */
+   	    case      125: rtctrim =  7; break; /* f=clock/(rtctrim+1)=125 */
+  	    case      112:
+  	    case      111: rtctrim =  8; break; /* f=clock/(rtctrim+1)=111.1 */
+   	    case      100: rtctrim =  9; break; /* f=clock/(rtctrim+1)=100 */
+  	    case       91:
+  	    case       90: rtctrim = 10; break; /* f=clock/(rtctrim+1)=90.9 */
+  	    case       84:
+  	    case       83: rtctrim = 11; break; /* f=clock/(rtctrim+1)=83.3 */
+  	    case       77:
+  	    case       76: rtctrim = 12; break; /* f=clock/(rtctrim+1)=76.9 */
+  	    case       72:
+  	    case       71: rtctrim = 13; break; /* f=clock/(rtctrim+1)=71.4 */
+  	    case       67:
+  	    case       66: rtctrim = 14; break; /* f=clock/(rtctrim+1)=66.7 */
+  	    case       63:
+  	    case       62: rtctrim = 15; break; /* f=clock/(rtctrim+1)=62.5 */
+  	    case       59:
+  	    case       58: rtctrim = 16; break; /* f=clock/(rtctrim+1)=58.8 */
+  	    case       56:
+  	    case       55: rtctrim = 17; break; /* f=clock/(rtctrim+1)=55.5 */
+  	    case       53:
+  	    case       52: rtctrim = 18; break; /* f=clock/(rtctrim+1)=52.6 */
+   	    case       50: rtctrim = 19; break; /* f=clock/(rtctrim+1)=50 */
+  	    case       48:
+  	    case       47: rtctrim = 20; break; /* f=clock/(rtctrim+1)=47.6 */
+  	    case       46:
+  	    case       45: rtctrim = 21; break; /* f=clock/(rtctrim+1)=45.5 */
+  	    case       44:
+  	    case       43: rtctrim = 22; break; /* f=clock/(rtctrim+1)=43.5 */
+  	    case       42:
+  	    case       41: rtctrim = 23; break; /* f=clock/(rtctrim+1)=41.6 */
+  	    case       40: rtctrim = 24; break; /* f=clock/(rtctrim+1)=40 */
+  	    case       39:
+  	    case       38: rtctrim = 25; break; /* f=clock/(rtctrim+1)=38.5 */
+  	    case       37: rtctrim = 26; break; /* f=clock/(rtctrim+1)=37.04 */
+  	    case       36: rtctrim = 27; break; /* f=clock/(rtctrim+1)=35.71 */
+  	    case       35:
+  	    case       34: rtctrim = 28; break; /* f=clock/(rtctrim+1)=34.48 */
+  	    case       33: rtctrim = 29; break; /* f=clock/(rtctrim+1)=33.33 */
+  	    case       32: rtctrim = 30; break; /* f=clock/(rtctrim+1)=32.25 */
+  	    case       31: rtctrim = 31; break; /* f=clock/(rtctrim+1)=31.25 */
+  	    case       30: rtctrim = 32; break; /* f=clock/(rtctrim+1)=30.30 */
+  	    case       29: rtctrim = 33; break; /* f=clock/(rtctrim+1)=29.41 */
+  	    case       28: rtctrim = 35; break; /* f=clock/(rtctrim+1)=27.77 */
+  	    case       27: rtctrim = 36; break; /* f=clock/(rtctrim+1)=27.03 */
+  	    case       26: rtctrim = 37; break; /* f=clock/(rtctrim+1)=26.32 */
+  	    case       25: rtctrim = 39; break; /* f=clock/(rtctrim+1)=25 */
+  	    case       24: rtctrim = 41; break; /* f=clock/(rtctrim+1)=23.81 */
+  	    case       23: rtctrim = 42; break; /* f=clock/(rtctrim+1)=23.26 */
+  	    case       22: rtctrim = 44; break; /* f=clock/(rtctrim+1)=22.22 */
+  	    case       21: rtctrim = 47; break; /* f=clock/(rtctrim+1)=20.83 */
+  	    case       20: rtctrim = 49; break; /* f=clock/(rtctrim+1)=20 */
+  	    case       19: rtctrim = 52; break; /* f=clock/(rtctrim+1)=18.87 */
+  	    case       18: rtctrim = 55; break; /* f=clock/(rtctrim+1)=17.86 */
+  	    case       17: rtctrim = 58; break; /* f=clock/(rtctrim+1)=16.95 */
+  	    case       16: rtctrim = 62; break; /* f=clock/(rtctrim+1)=15.87 */
+  	    case       15: rtctrim = 66; break; /* f=clock/(rtctrim+1)=14.93 */
+  	    case       14: rtctrim = 70; break; /* f=clock/(rtctrim+1)=14.09 */
+  	    case       13: rtctrim = 76; break; /* f=clock/(rtctrim+1)=12.99 */
+  	    case       12: rtctrim = 82; break; /* f=clock/(rtctrim+1)=12.05 */
+  	    case       11: rtctrim = 90; break; /* f=clock/(rtctrim+1)=10.99 */
+  	    case       10: rtctrim = 99; break; /* f=clock/(rtctrim+1)=10 */
+  	    case        9: rtctrim =110; break; /* f=clock/(rtctrim+1)=9.009 */
+  	    case        8: rtctrim =124; break; /* f=clock/(rtctrim+1)=8 */
+  	    case        7: rtctrim =142; break; /* f=clock/(rtctrim+1)=6.993 */
+  	    case        6: rtctrim =166; break; /* f=clock/(rtctrim+1)=5.988 */
+  	    case        5: rtctrim =199; break; /* f=clock/(rtctrim+1)=5 */
+  	    case        4: rtctrim =249; break; /* f=clock/(rtctrim+1)=4 */
+  	    case        3: rtctrim =332; break; /* f=clock/(rtctrim+1)=3.003 */
+  	    case        2: rtctrim =499; break; /* f=clock/(rtctrim+1)=2 */
+  	    case        1: rtctrim =999; break; /* f=clock/(rtctrim+1)=1 */
+	    default: {
+//#ifdef RTC_DEBUG
+	        printk(KERN_WARNING DRIVER RTC_VERSION ", Invalid periodic freq.\n");
+	        printk(KERN_WARNING "Valid values are 1000/n rounded to an integer > 0.\n");
+//#endif
+                return -EDOM; // -EINVAL;
+	    }
+	}
+
+	if ((arg > 64) && !(capable(CAP_SYS_RESOURCE))) return -EACCES;
+
+	tick_set = 0;
+	for (attempts=0; (attempts<timeout) && (tick_set==0); attempts++) {
+//	    spin_lock_irqsave(&rtc_set_lock, rtc_set_flags);
+
+	    cntrctrl=readl(SYS_COUNTER_CNTRL);
+	    if (!(cntrctrl & SYS_CNTRCTRL_RTS))
+	    { /* can write sys_rtctrim */
+		writel(rtctrim, SYS_RTCTRIM);
+		tick_set = 1;
+#ifdef RTC_DEBUG
+		corr=freq/(rtctrim+1);
+		printk(KERN_INFO DRIVER RTC_VERSION ", rtc trim set to %lu.\n", rtctrim);
+		printk(KERN_INFO DRIVER RTC_VERSION ", corresponding f=%u.%03lu Hz.\n", 
+                    corr, ((freq-corr*(rtctrim+1))*1000)/(rtctrim+1));
 #endif
-	case RTC_ALM_READ:	/* Read the present alarm time */
-	{
-		/*
-		 * This returns a struct rtc_time. Reading >= 0xc0
-		 * means "don't care" or "match all". Only the tm_hour,
-		 * tm_min, and tm_sec values are filled in.
-		 */
-		memset(&wtime, 0, sizeof(struct rtc_time));
-		get_rtc_alm_time(&wtime);
-		break; 
+		stab = 0; /* inform rtc_read */
+	    }
+	
+//	    spin_unlock_irqrestore(&rtc_set_lock, rtc_set_flags);
 	}
-	case RTC_ALM_SET:	/* Store a time into the alarm */
-	{
-		/*
-		 * This expects a struct rtc_time. Writing 0xff means
-		 * "don't care" or "match all". Only the tm_hour,
-		 * tm_min and tm_sec are used.
-		 */
-		unsigned char hrs, min, sec;
-		struct rtc_time alm_tm;
-
-		if (copy_from_user(&alm_tm, (struct rtc_time*)arg,
-				   sizeof(struct rtc_time)))
-			return -EFAULT;
-
-		hrs = alm_tm.tm_hour;
-		min = alm_tm.tm_min;
-		sec = alm_tm.tm_sec;
-
-		spin_lock_irq(&rtc_lock);
-		if (!(CMOS_READ(RTC_CONTROL) & RTC_DM_BINARY) ||
-		    RTC_ALWAYS_BCD)
-		{
-			if (sec < 60) BIN_TO_BCD(sec);
-			else sec = 0xff;
-
-			if (min < 60) BIN_TO_BCD(min);
-			else min = 0xff;
-
-			if (hrs < 24) BIN_TO_BCD(hrs);
-			else hrs = 0xff;
-		}
-		CMOS_WRITE(hrs, RTC_HOURS_ALARM);
-		CMOS_WRITE(min, RTC_MINUTES_ALARM);
-		CMOS_WRITE(sec, RTC_SECONDS_ALARM);
-		spin_unlock_irq(&rtc_lock);
+	if (tick_set < 1) return -EAGAIN;
 
-		return 0;
-	}
-	case RTC_RD_TIME:	/* Read the time/date from RTC	*/
-	{
-		memset(&wtime, 0, sizeof(struct rtc_time));
-		get_rtc_time(&wtime);
-		break;
+	return 0;
+    case RTC_IRQP_READ: /* Read periodic irq frequency */
+ 	rtctrim = readl(SYS_RTCTRIM); /* Divide=sys_rtctrim+1, max 16 bits */
+	rtctrim &= 0xFFFF;
+        rtctrim++;
+	irq_freq = freq / rtctrim;
+// 	trim = readl(SYS_TOYTRIM); /* Divide=sys_toytrim+1, max 16 bits */
+//	trim &= 0xFFFF;
+//      trim++;
+//	irq_freq = freq / trim;
+#ifdef RTC_DEBUG
+	printk(KERN_INFO DRIVER RTC_VERSION ", reported freq %01lu.\n", irq_freq);
+#endif
+	return put_user(irq_freq, (unsigned long *) arg);
+    case RTC_PIE_ON: /* Enable periodic irqs */
+        if (got_period_irq == 1) {
+
+	    rtctrim = readl(SYS_RTCTRIM); /* Divide=sys_rtctrim+1, max 16 bits */
+	    rtctrim &= 0xFFFF;
+	    rtctrim++;
+	    if (((freq/rtctrim) > 64) && !(capable(CAP_SYS_RESOURCE))) return -EACCES;
+
+	    writel(0x00040000, IC0_MASKSET);   /* rtc tick, enable irq in PIC */
+#ifdef RTC_DEBUG
+	    printk(KERN_INFO DRIVER RTC_VERSION ", periodic irq enabled.\n");
+#endif
+	} else if (got_tick_irq ==1) { /* fallback to fixed f=125 Hz */
+	    trim = readl(SYS_TOYTRIM); /* Divide=sys_toytrim+1, max 16 bits */
+	    trim &= 0xFFFF;
+	    trim++;
+	    if (((freq/trim) > 64) && !(capable(CAP_SYS_RESOURCE))) return -EACCES;
+
+	    writel(0x00004000, IC0_MASKSET);   /* toy tick, enable irq in PIC */
+#ifdef RTC_DEBUG
+	    printk(KERN_INFO DRIVER RTC_VERSION ", periodic/tick irq enabled.\n");
+#endif
+	} else {
+	    printk(KERN_WARNING DRIVER RTC_VERSION ", periodic irq not available.\n");
+	    return -EINVAL;
 	}
-	case RTC_SET_TIME:	/* Set the RTC */
-	{
-		struct rtc_time rtc_tm;
-		unsigned char mon, day, hrs, min, sec, leap_yr;
-		unsigned char save_control, save_freq_select;
-		unsigned int yrs;
-#ifdef CONFIG_DECSTATION
-		unsigned int real_yrs;
-#endif
-
-		if (!capable(CAP_SYS_TIME))
-			return -EACCES;
-
-		if (copy_from_user(&rtc_tm, (struct rtc_time*)arg,
-				   sizeof(struct rtc_time)))
-			return -EFAULT;
-
-		yrs = rtc_tm.tm_year + 1900;
-		mon = rtc_tm.tm_mon + 1;   /* tm_mon starts at zero */
-		day = rtc_tm.tm_mday;
-		hrs = rtc_tm.tm_hour;
-		min = rtc_tm.tm_min;
-		sec = rtc_tm.tm_sec;
-
-		if (yrs < 1970)
-			return -EINVAL;
-
-		leap_yr = ((!(yrs % 4) && (yrs % 100)) || !(yrs % 400));
-
-		if ((mon > 12) || (day == 0))
-			return -EINVAL;
-
-		if (day > (days_in_mo[mon] + ((mon == 2) && leap_yr)))
-			return -EINVAL;
-			
-		if ((hrs >= 24) || (min >= 60) || (sec >= 60))
-			return -EINVAL;
-
-		if ((yrs -= epoch) > 255)    /* They are unsigned */
-			return -EINVAL;
-
-		spin_lock_irq(&rtc_lock);
-#ifdef CONFIG_DECSTATION
-		real_yrs = yrs;
-		yrs = 72;
-
-		/*
-		 * We want to keep the year set to 73 until March
-		 * for non-leap years, so that Feb, 29th is handled
-		 * correctly.
-		 */
-		if (!leap_yr && mon < 3) {
-			real_yrs--;
-			yrs = 73;
-		}
-#endif
-		/* These limits and adjustments are independant of
-		 * whether the chip is in binary mode or not.
-		 */
-		if (yrs > 169) {
-			spin_unlock_irq(&rtc_lock);
-			return -EINVAL;
-		}
-		if (yrs >= 100)
-			yrs -= 100;
-
-		if (!(CMOS_READ(RTC_CONTROL) & RTC_DM_BINARY)
-		    || RTC_ALWAYS_BCD) {
-			BIN_TO_BCD(sec);
-			BIN_TO_BCD(min);
-			BIN_TO_BCD(hrs);
-			BIN_TO_BCD(day);
-			BIN_TO_BCD(mon);
-			BIN_TO_BCD(yrs);
-		}
-
-		save_control = CMOS_READ(RTC_CONTROL);
-		CMOS_WRITE((save_control|RTC_SET), RTC_CONTROL);
-		save_freq_select = CMOS_READ(RTC_FREQ_SELECT);
-		CMOS_WRITE((save_freq_select|RTC_DIV_RESET2), RTC_FREQ_SELECT);
-
-#ifdef CONFIG_DECSTATION
-		CMOS_WRITE(real_yrs, RTC_DEC_YEAR);
-#endif
-		CMOS_WRITE(yrs, RTC_YEAR);
-		CMOS_WRITE(mon, RTC_MONTH);
-		CMOS_WRITE(day, RTC_DAY_OF_MONTH);
-		CMOS_WRITE(hrs, RTC_HOURS);
-		CMOS_WRITE(min, RTC_MINUTES);
-		CMOS_WRITE(sec, RTC_SECONDS);
-
-		CMOS_WRITE(save_control, RTC_CONTROL);
-		CMOS_WRITE(save_freq_select, RTC_FREQ_SELECT);
 
-		spin_unlock_irq(&rtc_lock);
-		return 0;
-	}
-#if RTC_IRQ
-	case RTC_IRQP_READ:	/* Read the periodic IRQ rate.	*/
-	{
-		return put_user(rtc_freq, (unsigned long *)arg);
-	}
-	case RTC_IRQP_SET:	/* Set periodic IRQ rate.	*/
-	{
-		int tmp = 0;
-		unsigned char val;
-
-		/* 
-		 * The max we can do is 8192Hz.
-		 */
-		if ((arg < 2) || (arg > 8192))
-			return -EINVAL;
-		/*
-		 * We don't really want Joe User generating more
-		 * than 64Hz of interrupts on a multi-user machine.
-		 */
-		if ((arg > rtc_max_user_freq) && (!capable(CAP_SYS_RESOURCE)))
-			return -EACCES;
-
-		while (arg > (1<<tmp))
-			tmp++;
-
-		/*
-		 * Check that the input was really a power of 2.
-		 */
-		if (arg != (1<<tmp))
-			return -EINVAL;
-
-		spin_lock_irq(&rtc_lock);
-		rtc_freq = arg;
-
-		val = CMOS_READ(RTC_FREQ_SELECT) & 0xf0;
-		val |= (16 - tmp);
-		CMOS_WRITE(val, RTC_FREQ_SELECT);
-		spin_unlock_irq(&rtc_lock);
-		return 0;
-	}
-#endif
-	case RTC_EPOCH_READ:	/* Read the epoch.	*/
-	{
-		return put_user (epoch, (unsigned long *)arg);
+	return 0;
+    case RTC_PIE_OFF: /* Disable periodic irqs */
+        if (got_period_irq == 1) { 
+            writel(0x00040000, IC0_MASKCLR); /* rtc tick, disable irq in PIC */
+#ifdef RTC_DEBUG
+	    printk(KERN_INFO DRIVER RTC_VERSION ", periodic irq disabled.\n");
+#endif
+	} else if (got_tick_irq ==1) { /* fallback to fixed f=125 Hz */
+            writel(0x00004000, IC0_MASKCLR); /* toy tick, disable irq in PIC */
+#ifdef RTC_DEBUG
+	    printk(KERN_INFO DRIVER RTC_VERSION ", periodic/tick irq disabled.\n");
+#endif
+	} else {
+	    printk(KERN_WARNING DRIVER RTC_VERSION ", periodic irq not available.\n");
+	    return -EINVAL;
 	}
-	case RTC_EPOCH_SET:	/* Set the epoch.	*/
-	{
-		/* 
-		 * There were no RTC clocks before 1900.
-		 */
-		if (arg < 1900)
-			return -EINVAL;
-
-		if (!capable(CAP_SYS_TIME))
-			return -EACCES;
 
-		epoch = arg;
-		return 0;
-	}
-	default:
-		return -ENOTTY;
-	}
-	return copy_to_user((void *)arg, &wtime, sizeof wtime) ? -EFAULT : 0;
-}
+	return 0;
+//    case RTC_AIE_ON: /* Enable alarm irqs */
+    case RTC_UIE_ON: /* Enable RTC irqs */
+        if (got_tick_irq == 0) return -EINVAL;
+
+ 	trim = readl(SYS_TOYTRIM); /* Divide=sys_toytrim+1, max 16 bits */
+	trim &= 0xFFFF;
+        trim++;
+	if (((freq / trim) > 64) && !(capable(CAP_SYS_RESOURCE))) return -EACCES;
+
+	writel(0x00004000, IC0_MASKSET);   /* toy tick, enable irq in PIC */	
+#ifdef RTC_DEBUG
+	printk(KERN_INFO DRIVER RTC_VERSION ", tick irq enabled.\n");
+#endif
+	
+	return 0;
+//    case RTC_AIE_OFF: /* Disable alarm irqs */
+    case RTC_UIE_OFF: /* Disable RTC irqs */
+        if (got_tick_irq == 0) return -EINVAL;
+
+        writel(0x00004000, IC0_MASKCLR); /* toy tick, disable irq in PIC */
+#ifdef RTC_DEBUG
+	printk(KERN_INFO DRIVER RTC_VERSION ", tick irq disabled.\n");
+#endif
+ 
+	return 0;
+    default:
+	printk(KERN_WARNING DRIVER RTC_VERSION 
+            ", invalid or unimplemented ioctl command.\n");
+	return -EINVAL;
+    }
+} /* rtc_ioctl */
 
-/*
- *	We enforce only one user at a time here with the open/close.
- *	Also clear the previous interrupt data on an open, and clean
- *	up things on a close.
- */
 
-/* We use rtc_lock to protect against concurrent opens. So the BKL is not
- * needed here. Or anywhere else in this driver. */
-static int rtc_open(struct inode *inode, struct file *file)
+static void rtc_tick_handler(int irq, void *dev_id, struct pt_regs *cpuregs)
 {
-	spin_lock_irq (&rtc_lock);
-
-	if(rtc_status & RTC_IS_OPEN)
-		goto out_busy;
+    writel(0x00040000, IC0_RISINGCLR); /* rtc tick, clr rising edge detect */
 
-	rtc_status |= RTC_IS_OPEN;
+    new_eon=readl(SYS_RTCMATCH2);
+    new_pcnt=readl(SYS_RTCREAD);
+    /* Check that new eon did not occur right now, if so reread */
+    if ((new_eon == 1 + readl(SYS_RTCREAD))) {
+        new_pcnt=readl(SYS_RTCREAD);
+	new_eon++; 
+    }
+    wake_up_interruptible(&period_q);
+} /* rtc_tick_handler */
 
-	rtc_irq_data = 0;
-	spin_unlock_irq (&rtc_lock);
-	return 0;
-
-out_busy:
-	spin_unlock_irq (&rtc_lock);
-	return -EBUSY;
-}
-
-static int rtc_fasync (int fd, struct file *filp, int on)
 
+static void toy_tick_handler(int irq, void *dev_id, struct pt_regs *cpuregs)
 {
-	return fasync_helper (fd, filp, on, &rtc_async_queue);
-}
+    writel(0x00004000, IC0_RISINGCLR); /* toy tick, clr rising edge detect */
 
-static int rtc_release(struct inode *inode, struct file *file)
-{
-#if RTC_IRQ
-	unsigned char tmp;
+    if (got_period_irq == 0) { /* fallback to fixed f=125 Hz */
+        new_year=readl(SYS_TOYMATCH2);
+        new_cnt=readl(SYS_TOYREAD);
+        /* Check that new year did not occur right now, if so reread */
+        if ((new_year == 1 + readl(SYS_TOYREAD))) {
+            new_cnt=readl(SYS_TOYREAD);
+    	    new_year++; 
+        }
+        wake_up_interruptible(&period_q);
+    }
+} /* toy_tick_handler */
 
-	if (rtc_has_irq == 0)
-		goto no_irq;
 
-	/*
-	 * Turn off all interrupts once the device is no longer
-	 * in use, and clear the data.
-	 */
-
-	spin_lock_irq(&rtc_lock);
-	tmp = CMOS_READ(RTC_CONTROL);
-	tmp &=  ~RTC_PIE;
-	tmp &=  ~RTC_AIE;
-	tmp &=  ~RTC_UIE;
-	CMOS_WRITE(tmp, RTC_CONTROL);
-	CMOS_READ(RTC_INTR_FLAGS);
-
-	if (rtc_status & RTC_TIMER_ON) {
-		rtc_status &= ~RTC_TIMER_ON;
-		del_timer(&rtc_irq_timer);
-	}
-	spin_unlock_irq(&rtc_lock);
+static void eon_elapsed_handler(int irq, void *dev_id, struct pt_regs *cpuregs)
+{
+    unsigned long eon;
+    unsigned long curr_tick, wrap_tick;
+    unsigned long cntrctrl;
+
+//  if (0x00080000 & readl(IC0_RISINGRD)) {
+        writel(0x00080000, IC0_RISINGCLR); /* rtc match 0, clr rising edge detect */
+
+	eon = readl(SYS_RTCMATCH2);
+        wrap_tick = readl(SYS_RTCMATCH0);
+
+	eon++;
+	cntrctrl=readl(SYS_COUNTER_CNTRL);
+	if (cntrctrl & SYS_CNTRCTRL_RM2) write_error++;
+	curr_tick=readl(SYS_RTCREAD);
+	if (curr_tick < wrap_tick) {
+	    spurious_irq++; /* for debug purposes */
+        } else {
+	    /* Write to sys_rtcmatch2 without checks */
+	    writel(eon, SYS_RTCMATCH2);
+	    eon_irq++; /* for debug purposes */
+	}    
+//  } /* else not our interrupt */
+//  else {
+//      spurious_irq++; /* for debug purposes */
+//  }
+} /* eon_elapsed_handler */
 
-	if (file->f_flags & FASYNC) {
-		rtc_fasync (-1, file, 0);
-	}
-no_irq:
-#endif
 
-	spin_lock_irq (&rtc_lock);
-	rtc_irq_data = 0;
-	spin_unlock_irq (&rtc_lock);
+static void year_elapsed_handler(int irq, void *dev_id, struct pt_regs *cpuregs)
+{
+    unsigned long year;
+    unsigned long curr_tick, wrap_tick;
+    unsigned char leap_yr;
+    unsigned long trim;
+    unsigned long cntrctrl;
+
+#ifdef RTC_DEBUG
+    cp0_cause = cpuregs->cp0_cause;
+    cp0_status = cpuregs->cp0_status;
+//    ic0_risingrd = readl(IC0_RISINGRD); /* Kernel seems to have cleared it already */
+//    ic0_fallingrd = readl(IC0_FALLINGRD);
+//    ic0_req0int = readl(IC0_REQ0INT);
+#endif
+
+//  if (0x00008000 & readl(IC0_RISINGRD)) {
+        writel(0x00008000, IC0_RISINGCLR); /* match 0, clr rising edge detect */
+
+ 	trim = readl(SYS_TOYTRIM); /* Divide=sys_toytrim+1, max 16 bits */
+	trim &= 0xFFFF;
+        trim++; 
+	year = readl(SYS_TOYMATCH2);
+	leap_yr = ((!(year % 4) && (year % 100)) || !(year % 400));
+	wrap_tick = yearly_seconds_normal + leap_yr * addl_seconds_leap;
+        wrap_tick = wrap_tick * (freq / trim); /* ticks this year */
+
+	year++;
+	cntrctrl=readl(SYS_COUNTER_CNTRL);
+	if (!(!(cntrctrl & SYS_CNTRCTRL_TS) && !(cntrctrl & SYS_CNTRCTRL_TM0) && !(cntrctrl & SYS_CNTRCTRL_TM2)))
+ 	    write_error++;
+	curr_tick=readl(SYS_TOYREAD);
+	if (curr_tick < wrap_tick) {
+	    spurious_irq++; /* for debug purposes */
+        } else {
+	    curr_tick -= wrap_tick; /* if delayed by other interrupt */
+	    /* Write to sys_toywrite without checks, might collide with RTC_SET_TIME */
+	    writel(curr_tick, SYS_TOYWRITE);
+	    /* Write to sys_toymatch2 without checks, might collide with RTC_SET_TIME */
+	    writel(year, SYS_TOYMATCH2);
+	    leap_yr = ((!(year % 4) && (year % 100)) || !(year % 400));
+	    wrap_tick = yearly_seconds_normal + leap_yr * addl_seconds_leap;
+	    wrap_tick = wrap_tick * (freq / trim); /* ticks this year */
+	    /* Write to sys_toymatch0 without checks, might collide with RTC_SET_TIME */
+	    writel(wrap_tick, SYS_TOYMATCH0);
+	    year_irq++; /* for debug purposes */
+	}    
+//  } /* else not our interrupt */
+//  else {
+//      spurious_irq++; /* for debug purposes */
+//  }
+} /* year_elapsed_handler */
 
-	/* No need for locking -- nobody else can do anything until this rmw is
-	 * committed, and no timer is running. */
-	rtc_status &= ~RTC_IS_OPEN;
-	return 0;
-}
 
-#if RTC_IRQ
-/* Called without the kernel lock - fine */
-static unsigned int rtc_poll(struct file *file, poll_table *wait)
+static int rtc_open(struct inode *inode, struct file *file)
+/* spinlock is used against, two processes getting the idea to open concurrently. */
 {
-	unsigned long l;
-
-	if (rtc_has_irq == 0)
-		return 0;
+    unsigned long rtc_open_flags; /* flags must not be passed to other functions */
+#ifdef RTC_DEBUG
+    printk(KERN_INFO DRIVER RTC_VERSION ", open started.\n");
+#endif
+    spin_lock_irqsave(&rtc_open_lock, rtc_open_flags);
 
-	poll_wait(file, &rtc_wait, wait);
+    if (rtc_status & RTC_IS_OPEN) {
+	spin_unlock_irqrestore(&rtc_open_lock, rtc_open_flags);
+	return -EBUSY;
+    }
 
-	spin_lock_irq (&rtc_lock);
-	l = rtc_irq_data;
-	spin_unlock_irq (&rtc_lock);
+    rtc_status |= RTC_IS_OPEN;
 
-	if (l != 0)
-		return POLLIN | POLLRDNORM;
-	return 0;
-}
+    old_year=readl(SYS_TOYMATCH2);
+    old_cnt=readl(SYS_TOYREAD);
+    /* Check that new year did not occur right now, if so reread */
+    if (old_year == 1 + readl(SYS_TOYREAD)) {
+        old_cnt=readl(SYS_TOYREAD);
+	old_year++; 
+    }
+    old_eon=readl(SYS_RTCMATCH2);
+    old_pcnt=readl(SYS_RTCREAD);
+    /* Check that new eon did not occur right now, if so reread */
+    if (old_eon == 1 + readl(SYS_RTCREAD)) {
+        old_pcnt=readl(SYS_RTCREAD);
+	old_eon++; 
+    }
+    stab=1; 
+
+    spin_unlock_irqrestore(&rtc_open_lock, rtc_open_flags);
+#ifdef RTC_DEBUG
+    printk(KERN_INFO DRIVER RTC_VERSION ", open finished.\n");
 #endif
+    return 0;
+} /* rtc_open */
 
-/*
- *	The various file operations we support.
- */
-
-static struct file_operations rtc_fops = {
-	owner:		THIS_MODULE,
-	llseek:		no_llseek,
-	read:		rtc_read,
-#if RTC_IRQ
-	poll:		rtc_poll,
-#endif
-	ioctl:		rtc_ioctl,
-	open:		rtc_open,
-	release:	rtc_release,
-	fasync:		rtc_fasync,
-};
 
-static struct miscdevice rtc_dev=
+static int rtc_release(struct inode *inode, struct file *file)
 {
-	RTC_MINOR,
-	"rtc",
-	&rtc_fops
-};
+    unsigned long rtc_restore_flags; /* flags must not be passed to other functions */
 
-static int __init rtc_init(void)
-{
-#if defined(__alpha__) || defined(__mips__)
-	unsigned int year, ctrl;
-	unsigned long uip_watchdog;
-	char *guess = NULL;
-#endif
-#ifdef __sparc__
-	struct linux_ebus *ebus;
-	struct linux_ebus_device *edev;
-#ifdef __sparc_v9__
-	struct isa_bridge *isa_br;
-	struct isa_device *isa_dev;
-#endif
-#endif
-#ifndef __sparc__
-	void *r;
-#endif
-
-#ifdef __sparc__
-	for_each_ebus(ebus) {
-		for_each_ebusdev(edev, ebus) {
-			if(strcmp(edev->prom_name, "rtc") == 0) {
-				rtc_port = edev->resource[0].start;
-				rtc_irq = edev->irqs[0];
-				goto found;
-			}
-		}
-	}
-#ifdef __sparc_v9__
-	for_each_isa(isa_br) {
-		for_each_isadev(isa_dev, isa_br) {
-			if (strcmp(isa_dev->prom_name, "rtc") == 0) {
-				rtc_port = isa_dev->resource.start;
-				rtc_irq = isa_dev->irq;
-				goto found;
-			}
-		}
-	}
+#ifdef RTC_DEBUG
+    printk(KERN_INFO DRIVER RTC_VERSION ", release started.\n");
 #endif
-	printk(KERN_ERR "rtc_init: no PC rtc found\n");
-	return -EIO;
-
-found:
-	if (rtc_irq == PCI_IRQ_NONE) {
-		rtc_has_irq = 0;
-		goto no_irq;
-	}
+    spin_lock_irqsave(&rtc_open_lock, rtc_restore_flags);
 
-	/*
-	 * XXX Interrupt pin #7 in Espresso is shared between RTC and
-	 * PCI Slot 2 INTA# (and some INTx# in Slot 1). SA_INTERRUPT here
-	 * is asking for trouble with add-on boards. Change to SA_SHIRQ.
-	 */
-	if (request_irq(rtc_irq, rtc_interrupt, SA_INTERRUPT, "rtc", (void *)&rtc_port)) {
-		/*
-		 * Standard way for sparc to print irq's is to use
-		 * __irq_itoa(). I think for EBus it's ok to use %d.
-		 */
-		printk(KERN_ERR "rtc: cannot register IRQ %d\n", rtc_irq);
-		return -EIO;
-	}
-no_irq:
-#else
-	if (RTC_IOMAPPED)
-		r = request_region(RTC_PORT(0), RTC_IO_EXTENT, "rtc");
-	else
-		r = request_mem_region(RTC_PORT(0), RTC_IO_EXTENT, "rtc");
-	if (!r) {
-		printk(KERN_ERR "rtc: I/O resource %lx is not free.\n",
-		       (long)(RTC_PORT(0)));
-		return -EIO;
-	}
+    rtc_status &= ~RTC_IS_OPEN;
 
-#if RTC_IRQ
-	if(request_irq(RTC_IRQ, rtc_interrupt, SA_INTERRUPT, "rtc", NULL)) {
-		/* Yeah right, seeing as irq 8 doesn't even hit the bus. */
-		printk(KERN_ERR "rtc: IRQ %d is not free.\n", RTC_IRQ);
-		if (RTC_IOMAPPED)
-			release_region(RTC_PORT(0), RTC_IO_EXTENT);
-		else
-			release_mem_region(RTC_PORT(0), RTC_IO_EXTENT);
-		return -EIO;
-	}
+    spin_unlock_irqrestore(&rtc_open_lock, rtc_restore_flags);
+#ifdef RTC_DEBUG
+    printk(KERN_INFO DRIVER RTC_VERSION ", release finished.\n");
 #endif
+    return 0;
+} /* rtc_release */
 
-#endif /* __sparc__ vs. others */
-
-	misc_register(&rtc_dev);
-	create_proc_read_entry ("driver/rtc", 0, 0, rtc_read_proc, NULL);
 
-#if defined(__alpha__) || defined(__mips__)
-	rtc_freq = HZ;
-	
-	/* Each operating system on an Alpha uses its own epoch.
-	   Let's try to guess which one we are using now. */
-	
-	uip_watchdog = jiffies;
-	if (rtc_is_updating() != 0)
-		while (jiffies - uip_watchdog < 2*HZ/100) { 
-			barrier();
-			cpu_relax();
-		}
-	
-	spin_lock_irq(&rtc_lock);
-	year = CMOS_READ(RTC_YEAR);
-	ctrl = CMOS_READ(RTC_CONTROL);
-	spin_unlock_irq(&rtc_lock);
-	
-	if (!(ctrl & RTC_DM_BINARY) || RTC_ALWAYS_BCD)
-		BCD_TO_BIN(year);       /* This should never happen... */
-	
-	if (year < 20) {
-		epoch = 2000;
-		guess = "SRM (post-2000)";
-	} else if (year >= 20 && year < 48) {
-		epoch = 1980;
-		guess = "ARC console";
-	} else if (year >= 48 && year < 72) {
-		epoch = 1952;
-		guess = "Digital UNIX";
-#if defined(__mips__)
-	} else if (year >= 72 && year < 74) {
-		epoch = 2000;
-		guess = "Digital DECstation";
-#else
-	} else if (year >= 70) {
-		epoch = 1900;
-		guess = "Standard PC (1900)";
-#endif
-	}
-	if (guess)
-		printk(KERN_INFO "rtc: %s epoch (%lu) detected\n", guess, epoch);
-#endif
-#if RTC_IRQ
-	if (rtc_has_irq == 0)
-		goto no_irq2;
-
-	init_timer(&rtc_irq_timer);
-	rtc_irq_timer.function = rtc_dropped_irq;
-	spin_lock_irq(&rtc_lock);
-	/* Initialize periodic freq. to CMOS reset default, which is 1024Hz */
-	CMOS_WRITE(((CMOS_READ(RTC_FREQ_SELECT) & 0xF0) | 0x06), RTC_FREQ_SELECT);
-	spin_unlock_irq(&rtc_lock);
-	rtc_freq = 1024;
-no_irq2:
+static ssize_t rtc_read(struct file *file, char *buf, size_t count, loff_t *ppos)
+{ /* rtc_read is NOT re-entrant */
+    ssize_t result;
+    unsigned long curr_tick, curr_year;
+    unsigned long curr_ptick, curr_eon;
+    //    float jiffies_per_tick;
+    unsigned long trim;
+    unsigned long wrap_tick;
+    unsigned long wrap_ptick = 0xFFFFFFFF;
+    unsigned char leap_yr;
+
+#ifdef RTC_DEBUG
+    sometimes = (sometimes + 1) % 2500; /* How often to print, % 1 -> never */
+    //    sometimes = 1; /* always */
+    if (sometimes == 1 ) 
+        printk(KERN_INFO DRIVER RTC_VERSION ", read started.\n");
+#endif
+
+    if ((got_period_irq == 0) && (got_tick_irq == 0)) return -EIO;
+
+    //    init_waitqueue_head (&period_q);
+
+    if (got_period_irq == 1) {
+        curr_ptick=readl(SYS_RTCREAD);
+#ifdef RTC_DEBUG
+	if (sometimes == 1 ) 
+            printk(KERN_INFO "RTC: process %i (%s) is going to sleep at periodic tick %lu.\n", 
+	        current->pid, current->comm, curr_ptick);
+	sleep_diff=curr_ptick-old_pcnt;
+#endif
+//    wait_event_interruptible(period_q, (new_cnt>old_cnt));
+//    wait_event_interruptible(period_q, ((new_year>old_year) || (new_cnt>old_cnt)));
+//    wait_event_interruptible(period_q, ((new_year>old_year) || (new_cnt>old_cnt) || (stab==0)));
+	wait_event_interruptible(period_q, ((new_eon!=old_eon) || (new_pcnt!=old_pcnt) || (stab==0)));
+
+	curr_eon=readl(SYS_RTCMATCH2);
+	curr_ptick=readl(SYS_RTCREAD);
+        /* Check that new eon did not occur right now, if so reread */
+	if ((curr_eon == 1 + readl(SYS_RTCREAD))) {
+	    curr_ptick=readl(SYS_RTCREAD);
+	    curr_eon++; 
+	}
+
+#ifdef RTC_DEBUG
+	if (sometimes == 1 ) 
+	    printk(KERN_INFO "RTC: process %i (%s) has woken at periodic tick %lu.\n", 
+	        current->pid, current->comm, curr_ptick);
+#endif
+
+	if (curr_eon == old_eon) {
+	    if (old_pcnt>curr_ptick) {
+	        result = 0;
+		printk(KERN_WARNING "RTC: clock is decrementing, returning 0x0 as value.\n");
+	    } else {
+	        result = (curr_ptick-old_pcnt) << 8;
+	    }
+	} else if (curr_eon == old_eon+1) {
+	    if (old_pcnt-curr_ptick>wrap_ptick) {
+	        result = 0;
+		printk(KERN_WARNING "RTC: clock is decrementing, returning 0x0 as value.\n");
+	    } else {
+	        result = (curr_ptick+(wrap_ptick-old_pcnt)) << 8;
+	    }
+	} else {
+	    result = 0xFFFFFFFF;
+	    printk(KERN_WARNING "RTC: eon has jumped, returning 0xFFFFFFFF as value.\n");
+	}
+
+	if (stab == 0) {
+	    result = 0xFFFFFFFF;
+	    printk(KERN_WARNING "RTC: first rtc_read, returning 0xFFFFFFFF as value.\n");
+	    stab = 1;
+	}
+
+#ifdef RTC_DEBUG
+	if (result == 0xFFFFFFFF) {
+	    tick_stat[255]++;
+	} else if ((result>>8) > 253) {
+	    tick_stat[254]++;
+	} else {
+	    tick_stat[result>>8]++;
+	} 
+
+	if (sometimes == 1 ) 
+	    printk(KERN_INFO "RTC: delta periodic ticks: %01u.\n", result>>8);
+#endif
+	old_pcnt = curr_ptick;
+	old_eon = curr_eon;
+    }
+//-----------------------------------------------------------------------------
+    else /* got_tick_irq == 1, fallback to fixed f=125 Hz */
+    {
+	curr_tick=readl(SYS_TOYREAD);
+#ifdef RTC_DEBUG
+	if (sometimes == 1 ) 
+	    printk(KERN_INFO "RTC: process %i (%s) is going to sleep at tick %lu.\n", 
+	        current->pid, current->comm, curr_tick);
+	sleep_diff=curr_tick-old_cnt;
+#endif
+//    wait_event_interruptible(period_q, (new_cnt>old_cnt));
+//    wait_event_interruptible(period_q, ((new_year>old_year) || (new_cnt>old_cnt)));
+//    wait_event_interruptible(period_q, ((new_year>old_year) || (new_cnt>old_cnt) || (stab==0)));
+	wait_event_interruptible(period_q, ((new_year!=old_year) || (new_cnt!=old_cnt) || (stab==0)));
+
+	curr_year=readl(SYS_TOYMATCH2);
+	curr_tick=readl(SYS_TOYREAD);
+        /* Check that new year did not occur right now, if so reread */
+	if ((curr_year == 1 + readl(SYS_TOYREAD))) {
+	    curr_tick=readl(SYS_TOYREAD);
+	    curr_year++; 
+	}
+
+#ifdef RTC_DEBUG
+	if (sometimes == 1 ) 
+	    printk(KERN_INFO "RTC: process %i (%s) has woken at tick %lu.\n", 
+	        current->pid, current->comm, curr_tick);
+#endif
+
+	trim = readl(SYS_TOYTRIM); /* Divide=sys_toytrim+1, max 16 bits */
+	trim &= 0xFFFF;
+	trim++; 
+    
+	if (curr_year == old_year) {
+	    if (old_cnt>curr_tick) {
+	        result = 0;
+		printk(KERN_WARNING "RTC: clock is decrementing, returning 0x0 as value.\n");
+	    } else {
+	        result = (curr_tick-old_cnt) << 8;
+	    }
+	} else if (curr_year == old_year+1) {
+	    leap_yr = ((!(old_year % 4) && (old_year % 100)) || !(old_year % 400));
+	    wrap_tick = yearly_seconds_normal + leap_yr * addl_seconds_leap;
+	    wrap_tick = wrap_tick * (freq / trim); /* ticks last year */
+	    if (old_cnt>curr_tick+wrap_tick) {
+	        result = 0;
+		printk(KERN_WARNING "RTC: clock is decrementing, returning 0x0 as value.\n");
+	    } else {
+	        result = (curr_tick+wrap_tick-old_cnt) << 8;
+	    }
+	} else {
+	    result = 0xFFFFFFFF;
+	    printk(KERN_WARNING "RTC: year has jumped, returning 0xFFFFFFFF as value.\n");
+	}
+
+	if (stab == 0) {
+	    result = 0xFFFFFFFF;
+	    printk(KERN_WARNING "RTC: first rtc_read, returning 0xFFFFFFFF as value.\n");
+	    stab = 1;
+	}
+
+#ifdef RTC_DEBUG
+	if (result == 0xFFFFFFFF) {
+	    tick_stat[255]++;
+	} else if ((result>>8) > 253) {
+	    tick_stat[254]++;
+	} else {
+	    tick_stat[result>>8]++;
+	} 
+
+	if (sometimes == 1 ) 
+	    printk(KERN_INFO "RTC: delta ticks: %01u.\n", result>>8);
+#endif
+	old_cnt = curr_tick;
+	old_year = curr_year;
+    }
+#ifdef RTC_DEBUG
+    if (sometimes == 1 ) 
+        printk(KERN_INFO DRIVER RTC_VERSION ", read finished.\n");
 #endif
+    return put_user(result, (size_t *)buf);
+} /* rtc_read */
 
-	(void) init_sysctl();
 
-	printk(KERN_INFO "Real Time Clock Driver v" RTC_VERSION "\n");
+/* File operations supported. */
 
-	return 0;
-}
+static struct file_operations rtc_fops = {
+    owner: THIS_MODULE,
+    llseek: no_llseek,
+    read: rtc_read,
+    ioctl: rtc_ioctl,
+    open: rtc_open,
+    release: rtc_release,
+};
 
-static void __exit rtc_exit (void)
-{
-	cleanup_sysctl();
-	remove_proc_entry ("driver/rtc", NULL);
-	misc_deregister(&rtc_dev);
-
-#ifdef __sparc__
-	if (rtc_has_irq)
-		free_irq (rtc_irq, &rtc_port);
-#else
-	if (RTC_IOMAPPED)
-		release_region(RTC_PORT(0), RTC_IO_EXTENT);
-	else
-		release_mem_region(RTC_PORT(0), RTC_IO_EXTENT);
-#if RTC_IRQ
-	if (rtc_has_irq)
-		free_irq (RTC_IRQ, NULL);
-#endif
-#endif /* __sparc__ */
-}
 
-module_init(rtc_init);
-module_exit(rtc_exit);
-EXPORT_NO_SYMBOLS;
+static struct miscdevice rtc_dev = {
+    RTC_MINOR,
+    "rtc",
+    &rtc_fops
+};
 
-#if RTC_IRQ
-/*
- * 	At IRQ rates >= 4096Hz, an interrupt may get lost altogether.
- *	(usually during an IDE disk interrupt, with IRQ unmasking off)
- *	Since the interrupt handler doesn't get called, the IRQ status
- *	byte doesn't get read, and the RTC stops generating interrupts.
- *	A timer is set, and will call this function if/when that happens.
- *	To get it out of this stalled state, we just read the status.
- *	At least a jiffy of interrupts (rtc_freq/HZ) will have been lost.
- *	(You *really* shouldn't be trying to use a non-realtime system 
- *	for something that requires a steady > 1KHz signal anyways.)
- */
 
-static void rtc_dropped_irq(unsigned long data)
+static int __init rtc_init(void)
 {
-	unsigned long freq;
-
-	spin_lock_irq (&rtc_lock);
+    unsigned long cntrctrl;
+    unsigned long rtc_init_flags; /* flags must not be passed to other functions */
+    int retcode = 0;
+
+#ifdef RTC_DEBUG
+    printk(KERN_INFO DRIVER RTC_VERSION ", initialization started.\n");
+#endif
+
+    misc_register(&rtc_dev);
+#ifdef RTC_DEBUG
+    printk(KERN_INFO DRIVER RTC_VERSION ", dev registered.\n");
+#endif
+    create_proc_read_entry("driver/rtc", 0, 0, rtc_read_proc, NULL);
+#ifdef RTC_DEBUG
+    printk(KERN_INFO DRIVER RTC_VERSION ", proc created.\n");
+#endif
+
+    spin_lock_irqsave(&rtc_init_lock, rtc_init_flags);
+
+    /* common TOY & RTC set-up */
+    writel(0xFFFFFFFF, SYS_PININPUTEN); /* Enable count during sleep */
+    /* sys_cntrctrl has only two write-bits: bypass, BP, & enable osc, EO */
+    writel(0x00004000, SYS_COUNTER_CNTRL); /* Select GPIO[1], disable XTAL clk */
+
+    /* TOY set-up */
+    /* Set divide default once, not for every open/close */
+    cntrctrl=readl(SYS_COUNTER_CNTRL);
+    if (cntrctrl & SYS_CNTRCTRL_TTS)
+    { /* cannot write sys_toytrim */
+        /* wait or report error */
+	printk(KERN_WARNING "RTC: problem setting TOY trim.\n");
+    }
+    writel(trim_default, SYS_TOYTRIM); /* Divide=trim+1, max 16 bits */
+    /* leave TOY value as is, set with RTC_SET_TIME */
+    cntrctrl=readl(SYS_COUNTER_CNTRL);
+    if (cntrctrl & SYS_CNTRCTRL_TM0)
+    { /* cannot write sys_toymatch0 */
+        /* wait or report error */
+	printk(KERN_WARNING "RTC: problem setting yearly tick.\n");
+    }
+    writel(yearly_ticks_default, SYS_TOYMATCH0); /* set wrap-around value irq */
+
+    /* RTC set-up */
+    /* Set divide default once, not for every open/close */
+    cntrctrl=readl(SYS_COUNTER_CNTRL);
+    if (cntrctrl & SYS_CNTRCTRL_RTS)
+    { /* cannot write sys_rtctrim */
+        /* wait or report error */
+	printk(KERN_WARNING "RTC: problem setting RTC trim.\n");
+    }
+    writel(trim_default, SYS_RTCTRIM); /* Divide=trim+1, max 16 bits */
+    /* leave RTC value as is, does not matter */
+    cntrctrl=readl(SYS_COUNTER_CNTRL);
+    if (cntrctrl & SYS_CNTRCTRL_RM0)
+    { /* cannot write sys_rtcmatch0 */
+        /* wait or report error */
+	printk(KERN_WARNING "RTC: problem setting RTC wrap tick.\n");
+    }
+    writel(0xFFFFFFFF, SYS_RTCMATCH0); /* set wrap-around value irq */
+
+//-----------------------------------------------------------------------------
+    /* interrupt set-up, yearly irq */
+    writel(0x00008000, IC0_SRCSET);    /* toy match 0, not test bit */
+    writel(0x00008000, IC0_CFG0SET);   /* toy match 0, rising edge irq */
+    writel(0x00008000, IC0_CFG1CLR);   /* AMD 30283C page 198 */
+    writel(0x00008000, IC0_CFG2CLR);
+    writel(0x00008000, IC0_ASSIGNSET); /* toy match 0, select CPU req 0 */
+    writel(0x00008000, IC0_WAKESET);   /* toy match 0, wakeup from idle on match */
+    writel(0x00008000, IC0_RISINGCLR); /* toy match 0, clr rising edge detect */
+#ifdef RTC_DEBUG
+    printk(KERN_INFO DRIVER RTC_VERSION ", requesting irq 15.\n");
+#endif
+    if (request_irq(15, year_elapsed_handler, SA_INTERRUPT, "/dev/rtc - year", TOYMATCH0_PTR))
+    /* (void *)&rtc_port */
+    {
+	printk(KERN_WARNING "RTC: cannot register IRQ %d. Yearly tick will be lost.\n", 15);
+//	spin_unlock_irqrestore(&rtc_init_lock, rtc_init_flags);
+//	return -EIO;
+	retcode = -EIO;
+    } else {
+#ifdef RTC_DEBUG
+	printk(KERN_INFO "RTC: got IRQ %d. Yearly tick interrupt available.\n", 15);
+#endif
+    }
+#ifdef RTC_DEBUG
+    printk(KERN_INFO DRIVER RTC_VERSION ", enabling irq 15.\n");
+#endif
+    writel(0x00008000, IC0_MASKSET);   /* toy match 0, enable irq in PIC */
+//-----------------------------------------------------------------------------
+    /* interrupt set-up, eon irq */
+    writel(0x00080000, IC0_SRCSET);    /* rtc match 0, not test bit */
+    writel(0x00080000, IC0_CFG0SET);   /* rtc match 0, rising edge irq */
+    writel(0x00080000, IC0_CFG1CLR);   /* AMD 30283C page 198 */
+    writel(0x00080000, IC0_CFG2CLR);
+    writel(0x00080000, IC0_ASSIGNSET); /* rtc match 0, select CPU req 0 */
+    writel(0x00080000, IC0_WAKESET);   /* rtc match 0, wakeup from idle on match */
+    writel(0x00080000, IC0_RISINGCLR); /* rtc match 0, clr rising edge detect */
+#ifdef RTC_DEBUG
+    printk(KERN_INFO DRIVER RTC_VERSION ", requesting irq 19.\n");
+#endif
+    if (request_irq(19, eon_elapsed_handler, SA_INTERRUPT, "/dev/rtc - wrap", RTCMATCH0_PTR))
+    /* (void *)&rtc_port */
+    {
+	printk(KERN_WARNING "RTC: cannot register IRQ %d. Periodic wrap-around will be lost.\n", 19);
+//	spin_unlock_irqrestore(&rtc_init_lock, rtc_init_flags);
+//	return -EIO;
+	retcode = -EIO;
+    } else {
+#ifdef RTC_DEBUG
+	printk(KERN_INFO "RTC: got IRQ %d. Periodic wrap-around interrupt available.\n", 19);
+#endif
+    }
+#ifdef RTC_DEBUG
+    printk(KERN_INFO DRIVER RTC_VERSION ", enabling irq 19.\n");
+#endif
+    writel(0x00080000, IC0_MASKSET);   /* rtc match 0, enable irq in PIC */
+//-----------------------------------------------------------------------------
+    /* interrupt set-up, toy counter tick */
+    writel(0x00004000, IC0_SRCSET);    /* toy tick, not test bit */
+    writel(0x00004000, IC0_CFG0SET);   /* toy tick, rising edge irq */
+    writel(0x00004000, IC0_CFG1CLR);   /* AMD 30283C page 198 */
+    writel(0x00004000, IC0_CFG2CLR);
+    writel(0x00004000, IC0_ASSIGNSET); /* toy tick, select CPU req 0 */
+    writel(0x00004000, IC0_WAKESET);   /* toy tick, wakeup from idle on tick */
+    writel(0x00004000, IC0_RISINGCLR); /* toy tick, clr rising edge detect */
+#ifdef RTC_DEBUG
+    printk(KERN_INFO DRIVER RTC_VERSION ", requesting irq 14.\n");
+#endif
+    if (request_irq(14, toy_tick_handler, SA_INTERRUPT, "/dev/rtc - tick", TOYTICK_PTR))
+    /* (void *)&rtc_port */
+    {
+	printk(KERN_WARNING "RTC: cannot register IRQ %d. Tick interrupt unavailable.\n", 14);
+//	spin_unlock_irqrestore(&rtc_init_lock, rtc_init_flags);
+//	return -EIO;
+	retcode = -EIO;
+    } else {
+#ifdef RTC_DEBUG
+	printk(KERN_INFO "RTC: got IRQ %d. Tick interrupt available.\n", 14);
+#endif
+        got_tick_irq = 1;
+    }
+#ifdef RTC_DEBUG
+    printk(KERN_INFO DRIVER RTC_VERSION ", disabling irq 14.\n");
+#endif
+    /* irq 14 enabled by ioctl command RTC_UIE_ON */
+    //writel(0x00004000, IC0_MASKSET);   /* toy tick, enable irq in PIC */
+    writel(0x00004000, IC0_MASKCLR);   /* toy tick, disable irq in PIC */
+//-----------------------------------------------------------------------------
+    /* interrupt set-up, rtc counter tick */
+    writel(0x00040000, IC0_SRCSET);    /* rtc tick, not test bit */
+    writel(0x00040000, IC0_CFG0SET);   /* rtc tick, rising edge irq */
+    writel(0x00040000, IC0_CFG1CLR);   /* AMD 30283C page 198 */
+    writel(0x00040000, IC0_CFG2CLR);
+    writel(0x00040000, IC0_ASSIGNSET); /* rtc tick, select CPU req 0 */
+    writel(0x00040000, IC0_WAKESET);   /* rtc tick, wakeup from idle on tick */
+    writel(0x00040000, IC0_RISINGCLR); /* rtc tick, clr rising edge detect */
+#ifdef RTC_DEBUG
+    printk(KERN_INFO DRIVER RTC_VERSION ", requesting irq 18.\n");
+#endif
+//    if (1) /* Test fallback */
+    if (request_irq(18, rtc_tick_handler, SA_INTERRUPT, "/dev/rtc - period", RTCTICK_PTR))
+    /* (void *)&rtc_port */
+    {
+	printk(KERN_WARNING "RTC: cannot register IRQ %d. Periodic interrupt unavailable.\n", 18);
+//	spin_unlock_irqrestore(&rtc_init_lock, rtc_init_flags);
+//	return -EIO; /* or fallback to irq 14 */
+	retcode = -EIO;
+    } else {
+#ifdef RTC_DEBUG
+	printk(KERN_INFO "RTC: got IRQ %d. Periodic interrupt available.\n", 18);
+#endif
+        got_period_irq = 1;
+    }
+#ifdef RTC_DEBUG
+    printk(KERN_INFO DRIVER RTC_VERSION ", disabling irq 18.\n");
+#endif
+    /* irq 18 enabled by ioctl command RTC_PIE_ON */
+    //writel(0x00040000, IC0_MASKSET);   /* rtc tick, enable irq in PIC */
+    writel(0x00040000, IC0_MASKCLR); /* rtc tick, disable irq in PIC */
+
+    spin_unlock_irqrestore(&rtc_init_lock, rtc_init_flags);
 
-	/* Just in case someone disabled the timer from behind our back... */
-	if (rtc_status & RTC_TIMER_ON)
-		mod_timer(&rtc_irq_timer, jiffies + HZ/rtc_freq + 2*HZ/100);
+    printk(KERN_INFO DRIVER RTC_VERSION ", initialized.\n");
 
-	rtc_irq_data += ((rtc_freq/HZ)<<8);
-	rtc_irq_data &= ~0xff;
-	rtc_irq_data |= (CMOS_READ(RTC_INTR_FLAGS) & 0xF0);	/* restart */
+    return retcode;
+} /* rtc_init */
 
-	freq = rtc_freq;
 
-	spin_unlock_irq(&rtc_lock);
-
-	printk(KERN_WARNING "rtc: lost some interrupts at %ldHz.\n", freq);
-
-	/* Now we have new data */
-	wake_up_interruptible(&rtc_wait);
+static void __exit rtc_exit(void)
+{
+    unsigned long rtc_exit_flags; /* flags must not be passed to other functions */
 
-	kill_fasync (&rtc_async_queue, SIGIO, POLL_IN);
-}
+#ifdef RTC_DEBUG
+    printk(KERN_INFO DRIVER RTC_VERSION ", exit started.\n");
 #endif
 
-/*
- *	Info exported via "/proc/driver/rtc".
- */
-
-static int rtc_proc_output (char *buf)
-{
-#define YN(bit) ((ctrl & bit) ? "yes" : "no")
-#define NY(bit) ((ctrl & bit) ? "no" : "yes")
-	char *p;
-	struct rtc_time tm;
-	unsigned char batt, ctrl;
-	unsigned long freq;
-
-	spin_lock_irq(&rtc_lock);
-	batt = CMOS_READ(RTC_VALID) & RTC_VRT;
-	ctrl = CMOS_READ(RTC_CONTROL);
-	freq = rtc_freq;
-	spin_unlock_irq(&rtc_lock);
-
-	p = buf;
-
-	get_rtc_time(&tm);
-
-	/*
-	 * There is no way to tell if the luser has the RTC set for local
-	 * time or for Universal Standard Time (GMT). Probably local though.
-	 */
-	p += sprintf(p,
-		     "rtc_time\t: %02d:%02d:%02d\n"
-		     "rtc_date\t: %04d-%02d-%02d\n"
-	 	     "rtc_epoch\t: %04lu\n",
-		     tm.tm_hour, tm.tm_min, tm.tm_sec,
-		     tm.tm_year + 1900, tm.tm_mon + 1, tm.tm_mday, epoch);
-
-	get_rtc_alm_time(&tm);
-
-	/*
-	 * We implicitly assume 24hr mode here. Alarm values >= 0xc0 will
-	 * match any value for that particular field. Values that are
-	 * greater than a valid time, but less than 0xc0 shouldn't appear.
-	 */
-	p += sprintf(p, "alarm\t\t: ");
-	if (tm.tm_hour <= 24)
-		p += sprintf(p, "%02d:", tm.tm_hour);
-	else
-		p += sprintf(p, "**:");
-
-	if (tm.tm_min <= 59)
-		p += sprintf(p, "%02d:", tm.tm_min);
-	else
-		p += sprintf(p, "**:");
-
-	if (tm.tm_sec <= 59)
-		p += sprintf(p, "%02d\n", tm.tm_sec);
-	else
-		p += sprintf(p, "**\n");
-
-	p += sprintf(p,
-		     "DST_enable\t: %s\n"
-		     "BCD\t\t: %s\n"
-		     "24hr\t\t: %s\n"
-		     "square_wave\t: %s\n"
-		     "alarm_IRQ\t: %s\n"
-		     "update_IRQ\t: %s\n"
-		     "periodic_IRQ\t: %s\n"
-		     "periodic_freq\t: %ld\n"
-		     "batt_status\t: %s\n",
-		     YN(RTC_DST_EN),
-		     NY(RTC_DM_BINARY),
-		     YN(RTC_24H),
-		     YN(RTC_SQWE),
-		     YN(RTC_AIE),
-		     YN(RTC_UIE),
-		     YN(RTC_PIE),
-		     freq,
-		     batt ? "okay" : "dead");
-
-	return  p - buf;
-#undef YN
-#undef NY
-}
-
-static int rtc_read_proc(char *page, char **start, off_t off,
-                         int count, int *eof, void *data)
-{
-        int len = rtc_proc_output (page);
-        if (len <= off+count) *eof = 1;
-        *start = page + off;
-        len -= off;
-        if (len>count) len = count;
-        if (len<0) len = 0;
-        return len;
-}
+    spin_lock_irqsave(&rtc_init_lock, rtc_exit_flags);
 
-/*
- * Returns true if a clock update is in progress
- */
-/* FIXME shouldn't this be above rtc_init to make it fully inlined? */
-static inline unsigned char rtc_is_updating(void)
-{
-	unsigned char uip;
+    writel(0x00080000, IC0_MASKCLR); /* rtc match 0, disable irq in PIC */
+    free_irq(19, RTCMATCH0_PTR);     /* rtc match 0, disable irq in CP0 reg 12, sel 0 */
+    writel(0x00008000, IC0_MASKCLR); /* toy match 0, disable irq in PIC */
+    free_irq(15, TOYMATCH0_PTR);     /* toy match 0, disable irq in CP0 reg 12, sel 0 */
 
-	spin_lock_irq(&rtc_lock);
-	uip = (CMOS_READ(RTC_FREQ_SELECT) & RTC_UIP);
-	spin_unlock_irq(&rtc_lock);
-	return uip;
-}
+    if (got_tick_irq == 1) {
+        writel(0x00004000, IC0_MASKCLR); /* toy tick, disable irq in PIC */
+        free_irq(14, TOYTICK_PTR);       /* toy tick, disable irq in CP0 reg 12, sel 0 */
+        got_tick_irq = 0;
+    }
 
-static void get_rtc_time(struct rtc_time *rtc_tm)
-{
-	unsigned long uip_watchdog = jiffies;
-	unsigned char ctrl;
-#ifdef CONFIG_DECSTATION
-	unsigned int real_year;
-#endif
-
-	/*
-	 * read RTC once any update in progress is done. The update
-	 * can take just over 2ms. We wait 10 to 20ms. There is no need to
-	 * to poll-wait (up to 1s - eeccch) for the falling edge of RTC_UIP.
-	 * If you need to know *exactly* when a second has started, enable
-	 * periodic update complete interrupts, (via ioctl) and then 
-	 * immediately read /dev/rtc which will block until you get the IRQ.
-	 * Once the read clears, read the RTC time (again via ioctl). Easy.
-	 */
-
-	if (rtc_is_updating() != 0)
-		while (jiffies - uip_watchdog < 2*HZ/100) {
-			barrier();
-			cpu_relax();
-		}
-
-	/*
-	 * Only the values that we read from the RTC are set. We leave
-	 * tm_wday, tm_yday and tm_isdst untouched. Even though the
-	 * RTC has RTC_DAY_OF_WEEK, we ignore it, as it is only updated
-	 * by the RTC when initially set to a non-zero value.
-	 */
-	spin_lock_irq(&rtc_lock);
-	rtc_tm->tm_sec = CMOS_READ(RTC_SECONDS);
-	rtc_tm->tm_min = CMOS_READ(RTC_MINUTES);
-	rtc_tm->tm_hour = CMOS_READ(RTC_HOURS);
-	rtc_tm->tm_mday = CMOS_READ(RTC_DAY_OF_MONTH);
-	rtc_tm->tm_mon = CMOS_READ(RTC_MONTH);
-	rtc_tm->tm_year = CMOS_READ(RTC_YEAR);
-#ifdef CONFIG_DECSTATION
-	real_year = CMOS_READ(RTC_DEC_YEAR);
-#endif
-	ctrl = CMOS_READ(RTC_CONTROL);
-	spin_unlock_irq(&rtc_lock);
-
-	if (!(ctrl & RTC_DM_BINARY) || RTC_ALWAYS_BCD)
-	{
-		BCD_TO_BIN(rtc_tm->tm_sec);
-		BCD_TO_BIN(rtc_tm->tm_min);
-		BCD_TO_BIN(rtc_tm->tm_hour);
-		BCD_TO_BIN(rtc_tm->tm_mday);
-		BCD_TO_BIN(rtc_tm->tm_mon);
-		BCD_TO_BIN(rtc_tm->tm_year);
-	}
+    if (got_period_irq == 1) {
+        writel(0x00040000, IC0_MASKCLR); /* rtc tick, disable irq in PIC */
+        free_irq(18, RTCTICK_PTR);       /* rtc tick, disable irq in CP0 reg 12, sel 0 */
+        got_period_irq = 0;
+    }
+    /* Counters will continue, but not generating interrupts */
 
-#ifdef CONFIG_DECSTATION
-	rtc_tm->tm_year += real_year - 72;
-#endif
+    spin_unlock_irqrestore(&rtc_init_lock, rtc_exit_flags);
 
-	/*
-	 * Account for differences between how the RTC uses the values
-	 * and how they are defined in a struct rtc_time;
-	 */
-	if ((rtc_tm->tm_year += (epoch - 1900)) <= 69)
-		rtc_tm->tm_year += 100;
+    remove_proc_entry("driver/rtc", NULL);
+    misc_deregister(&rtc_dev);
 
-	rtc_tm->tm_mon--;
-}
+    printk(KERN_INFO DRIVER RTC_VERSION ", exited.\n");
+} /* rtc_exit */
 
-static void get_rtc_alm_time(struct rtc_time *alm_tm)
-{
-	unsigned char ctrl;
+module_init(rtc_init);
+module_exit(rtc_exit);
+EXPORT_NO_SYMBOLS;
 
-	/*
-	 * Only the values that we read from the RTC are set. That
-	 * means only tm_hour, tm_min, and tm_sec.
-	 */
-	spin_lock_irq(&rtc_lock);
-	alm_tm->tm_sec = CMOS_READ(RTC_SECONDS_ALARM);
-	alm_tm->tm_min = CMOS_READ(RTC_MINUTES_ALARM);
-	alm_tm->tm_hour = CMOS_READ(RTC_HOURS_ALARM);
-	ctrl = CMOS_READ(RTC_CONTROL);
-	spin_unlock_irq(&rtc_lock);
-
-	if (!(ctrl & RTC_DM_BINARY) || RTC_ALWAYS_BCD)
-	{
-		BCD_TO_BIN(alm_tm->tm_sec);
-		BCD_TO_BIN(alm_tm->tm_min);
-		BCD_TO_BIN(alm_tm->tm_hour);
-	}
-}
 
-#if RTC_IRQ
-/*
- * Used to disable/enable interrupts for any one of UIE, AIE, PIE.
- * Rumour has it that if you frob the interrupt enable/disable
- * bits in RTC_CONTROL, you should read RTC_INTR_FLAGS, to
- * ensure you actually start getting interrupts. Probably for
- * compatibility with older/broken chipset RTC implementations.
- * We also clear out any old irq data after an ioctl() that
- * meddles with the interrupt enable/disable bits.
- */
+/* Info exported via "/proc/driver/rtc". */
 
-static void mask_rtc_irq_bit(unsigned char bit)
+static int rtc_proc_output(char *buf)
 {
-	unsigned char val;
+    char *p;
+    struct rtc_time rtc_tm;
+    unsigned long trim, rtctrim;
+    unsigned short corr;
+#ifdef RTC_DEBUG
+    unsigned char index;
+#endif
+
+    au1550_get_time(&rtc_tm);
+
+    trim = readl(SYS_TOYTRIM); /* Divide=sys_toytrim+1, max 16 bits */
+    trim &= 0xFFFF;
+    trim++; 
+
+    rtctrim = readl(SYS_RTCTRIM); /* Divide=sys_rtctrim+1, max 16 bits */
+    rtctrim &= 0xFFFF;
+    rtctrim++; 
+    corr=freq/rtctrim;
+
+    p = buf;
+    p += sprintf(p,
+	"rtc_time     \t: %02d:%02d:%02d\n"
+	"rtc_date     \t: %04d-%02d-%02d\n"
+	"rtc_epoch    \t: %04u\n"
+#ifdef RTC_DEBUG
+        "year_IRQ     \t: %01lu\n"
+        "eon_IRQ      \t: %01lu\n"
+        "spurious_IRQ \t: %01lu\n"
+        "write error  \t: %01lu\n"
+        "toy tick     \t: %01u\n"
+        "year tick    \t: %01u\n"
+        "year         \t: %04u\n"
+        "periodic tick\t: %01u\n"
+        "cp0_cause    \t: %08lx\n"
+        "cp0_status   \t: %08lx\n"
+//      "ic0_risingrd \t: %08lx\n"
+//      "ic0_fallingrd\t: %08lx\n"
+//      "ic0_req0int  \t: %08lx\n"
+        "sleep diff   \t: %01d\n"
+#endif
+	"update_IRQ \t: %s\n"
+	"update_freq\t: %01lu Hz\n"
+	"periodic_IRQ \t: %s\n"
+	"periodic_freq\t: %u.%03lu Hz\n",
+	rtc_tm.tm_hour, rtc_tm.tm_min, rtc_tm.tm_sec,
+	epoch+rtc_tm.tm_year, rtc_tm.tm_mon + 1, rtc_tm.tm_mday, 
+	epoch, 
+#ifdef RTC_DEBUG
+	year_irq,
+	eon_irq,
+	spurious_irq,
+        write_error,
+	readl(SYS_TOYREAD),
+        readl(SYS_TOYMATCH0),
+        readl(SYS_TOYMATCH2),
+	readl(SYS_RTCREAD),
+        cp0_cause,
+        cp0_status,
+//        ic0_risingrd,
+//        ic0_fallingrd,
+//	  ic0_req0int,
+	sleep_diff,
+#endif
+        (readl(IC0_MASKRD) & 0x00004000) ? "enabled" : "disabled",
+	freq/trim,
+        (readl(IC0_MASKRD) & 0x00040000) ? "enabled" : "disabled",
+	corr, ((freq-corr*rtctrim)*1000)/rtctrim
+        );
+
+#ifdef RTC_DEBUG
+    p += sprintf(p, "Time between read statistics:\n");
+    for (index = 0; index < 254; index++) {
+        if (tick_stat[index]>0)
+            p += sprintf(p, "%05d tick(s)  \t: %10lu\n", index, tick_stat[index]);
+    }
+    index=254;
+    p += sprintf(p, " >253 ticks   \t: %10lu\n", tick_stat[index]);
+    index=255;
+    p += sprintf(p, "error ticks   \t: %10lu\n", tick_stat[index]);
+#endif
+	
+    return (p - buf);
+} /* rtc_proc_output */
 
-	spin_lock_irq(&rtc_lock);
-	val = CMOS_READ(RTC_CONTROL);
-	val &=  ~bit;
-	CMOS_WRITE(val, RTC_CONTROL);
-	CMOS_READ(RTC_INTR_FLAGS);
-
-	rtc_irq_data = 0;
-	spin_unlock_irq(&rtc_lock);
-}
 
-static void set_rtc_irq_bit(unsigned char bit)
+static int rtc_read_proc(char *page, char **start, off_t off, int count, int *eof, void *data)
 {
-	unsigned char val;
-
-	spin_lock_irq(&rtc_lock);
-	val = CMOS_READ(RTC_CONTROL);
-	val |= bit;
-	CMOS_WRITE(val, RTC_CONTROL);
-	CMOS_READ(RTC_INTR_FLAGS);
-
-	rtc_irq_data = 0;
-	spin_unlock_irq(&rtc_lock);
-}
+    int length = rtc_proc_output(page);
+#ifdef RTC_DEBUG
+    printk(KERN_INFO DRIVER RTC_VERSION ", read proc started.\n");
+#endif
+    if (length <= off + count) *eof = 1;
+    *start = page + off;
+    length -= off;
+    if (length > count) length = count;
+    if (length < 0) length = 0;
+#ifdef RTC_DEBUG
+    printk(KERN_INFO DRIVER RTC_VERSION ", read proc finished.\n");
 #endif
+    return length;
+} /* rtc_read_proc */
 
-MODULE_AUTHOR("Paul Gortmaker");
+MODULE_AUTHOR("K. Monell");
+MODULE_LICENSE("Proprietary");
 MODULE_LICENSE("GPL");
